
/*      Chainsaw.C -- takes a directory name as an argument     */
/*      and deletes all files and directories under that        */
/*      directory, including the directory itself.              */
/*      CAUTION: no 'are you sure?' prompts are given!          */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dir.h>
#include <dos.h>
#include <io.h>

void    erase_dir(char *d);

extern	unsigned _stklen = 0x4000;

char    cpath[81];
char    dpath[81];
int     fcount;
int     cdrive;
int     ndrive;
int     test_mode;
struct  ffblk ffm;
union   REGS regs;
struct  fcb FCB;

void    main(int argc, char *argv[])
        {
        printf("\n");

        if (argc < 2 || argc > 3)
            {
            printf("USAGE: chainsaw <directoryname> [REALLY]\n");
            exit(1);
            }

        test_mode = 1;
        if (argc == 3)
            {
            strupr(argv[2]);
            if (strcmp(argv[2], "REALLY") != 0)
                {
                printf("USAGE: chainsaw <directoryname> [REALLY]\n");
                exit(1);
                }
            test_mode = 0;
            }

        if (test_mode == 1)
            printf("Test Mode.  (Relax.)\n\n");

        strcpy(dpath, argv[1]);
        strupr(dpath);

        cdrive = getdisk();
        strcpy(cpath, "\\");
        getcurdir(0, &cpath[1]);

        if (dpath[1] == ':')
            ndrive = dpath[0] - 'A';
        else
            ndrive = cdrive;

        setdisk(ndrive);

        erase_dir(dpath);

        setdisk(cdrive);
        chdir(cpath);
        exit(0);
        }



void    erase_dir(char *d)
        {
        int     flag;
        struct  ffblk ff;

        strupr(d);
        if (chdir(d) != 0)
            {
            printf("%s is not a directory.\n", d);
            printf("USAGE: chainsaw <directoryname> [REALLY]\n");
            setdisk(cdrive);
            chdir(cpath);
            exit(1);
            }

        FCB.fcb_drive = 0;
        sprintf(FCB.fcb_name, "%s", "????????");
        sprintf(FCB.fcb_ext,  "%s", "???");
        regs.h.ah = 0x13;
        regs.x.dx = (unsigned) &FCB;

        if (test_mode == 0)
            intdos(&regs, &regs);

        flag=findfirst("*.*", &ff, FA_DIREC);
        while (flag == 0)
            {
            if (ff.ff_name[0] != '.')
                {
                if ((ff.ff_attrib & FA_DIREC) == FA_DIREC)
                    erase_dir(ff.ff_name);
                else
                if (test_mode == 0)
                    {
                    _chmod(ff.ff_name, 1, 0);
                    unlink(ff.ff_name);
                    }
                }
            flag = findnext(&ff);
            }

        chdir("..");
        printf("removing directory %s\n", d);

        if (test_mode == 0)
            rmdir(d);
        }

