
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dir.h>
#include <dos.h>

void    show_dir(char *d);

extern	unsigned _stklen = 0x4000;

char    cpath[81];
char    dpath[81];
int     recursion;
int     i;
int     cdrive;
int     ndrive;

void    main(int argc, char *argv[])
        {
        printf("\n");

        if (argc != 2)
            {
            printf("USAGE: treelist <directoryname>\n");
            exit(1);
            }

        strcpy(dpath, argv[1]);
        strupr(dpath);

        cdrive = getdisk();
        strcpy(cpath, "\\");
        getcurdir(0, &cpath[1]);

        if (dpath[1] == ':')
            ndrive = dpath[0] - 'A';
        else
            ndrive = cdrive;

        setdisk(ndrive);

        recursion = 0;
        show_dir(dpath);

        setdisk(cdrive);
        chdir(cpath);
        exit(0);
        }



void    show_dir(char *d)
        {
        int     flag, count;
        struct  ffblk ff;

        strupr(d);
        if (chdir(d) != 0)
            {
            printf("%s is not a directory.\n", d);
            printf("USAGE: treelist <directoryname>\n");
            setdisk(cdrive);
            chdir(cpath);
            exit(1);
            }

        printf("\n\n");
        for (i=0; i<recursion; i++)
            printf ("   ");

        printf("-- %s --\n", d);

        count = 0;
        flag=findfirst("*.*", &ff, FA_HIDDEN | FA_SYSTEM | FA_DIREC);
        for (i=0; i<recursion; i++)
            printf("   ");
        while (flag == 0)
            {
            if (ff.ff_name[0] != '.')
                if ( (ff.ff_attrib & FA_DIREC) != FA_DIREC)
                    {
                    strlwr(ff.ff_name);
                    printf("  %-12.12s", ff.ff_name);
                    count++;
                    if (count % 5 == 0)
                        {
                        printf("\n");
                        for (i=0; i<recursion; i++)
                            printf("   ");
                        }
                    }
            flag = findnext(&ff);
            }

        flag=findfirst("*.*", &ff, FA_HIDDEN | FA_SYSTEM | FA_DIREC);
        while (flag == 0)
            {
            if (ff.ff_name[0] != '.')
                if ( (ff.ff_attrib & FA_DIREC) == FA_DIREC)
                    {
                    recursion++;
                    show_dir(ff.ff_name);
                    }
            flag = findnext(&ff);
            }

        chdir("..");
        recursion--;
        }

